import java.io.*;
import java.util.*;

class SlideshowWriter {
    private boolean abs = false;
    SlideshowWriter() {}
    SlideshowWriter(boolean b) { this.abs = b; }
    protected void getImages(File topDir, Vector returnBuffer, boolean rec) {
	File children[] = topDir.listFiles();
	for (int i = 0; i < children.length; i++) {
	    if (rec && children[i].isDirectory()) {
		getImages(children[i], returnBuffer, true);
	    } else {
		String name = children[i].getPath();
		int dotIndex = name.lastIndexOf('.');
		if (dotIndex < 1) {
		    continue;
		}
		String extension = name.substring(dotIndex + 1);
		if (extension.equalsIgnoreCase("JPG") ||
		    extension.equalsIgnoreCase("GIF") ||
		    extension.equalsIgnoreCase("BMP") ||
		    extension.equalsIgnoreCase("PNG") ||
		    extension.equalsIgnoreCase("TIFF")) {
		    returnBuffer.add(name);
		}
	    }
	}
    }
    public boolean write(File topDir, String targetFileName, String title, boolean rec)
	throws IOException {
	Vector images = new Vector();
	getImages(topDir, images, rec);
	if (images.isEmpty()) return false;
	InputStream is = getClass().getResourceAsStream("slideshow.temp");
	if (is == null) throw new IOException("cannot open slideshow.temp");
	StringBuffer buffer = new StringBuffer();
	InputStreamReader reader = new InputStreamReader(is);
	for (int ch = reader.read(); ch >= 0; ch = reader.read()) {
	    buffer.append((char)ch);
	}
	reader.close();
	FileWriter fwriter = new FileWriter(new File(topDir, targetFileName));
	String template = buffer.toString();
	int index = template.indexOf(titleHole);
	fwriter.write(template.substring(0, index));
	fwriter.write(title);
	index += titleHole.length();
	int oindex = template.indexOf(optionHole, index);
	fwriter.write(template.substring(index, oindex));
	oindex += optionHole.length();
	int dirLen = topDir.toString().length() + 1;
	for (Enumeration e = images.elements(); e.hasMoreElements(); ) {
	    String path = (String)e.nextElement();
	    if (abs) {
		fwriter.write("<option>"  + path + "\r\n");
	    } else {
		fwriter.write("<option>"  + path.substring(dirLen) + "\r\n");
	    }
	}
	fwriter.write(template.substring(index));
	fwriter.close();
	return true;
    }
    private static String optionHole = "%options%", titleHole = "%title%";
}
